#
# Copyright (C) 1996-2001 Particle Corporation.
# Alex S. (Particle)
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
# 
# See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 

#
# Experimental version of Prof.Phreak
#

local @from = ("are you","you are","my",  "your","me", "i am",    "am i",    "i",  "myself",  "you");
local @to = (  "I am",   "I am",   "your","my",  "you","you are", "you are", "you","yourself","I");

local $db_load_count = 0;


# given name, loads database. returns reference to db
sub load_database {
   my ($dbname) = @_;
   # load database of simple keywords
   open(IN,"<$dbname") || die;
   my $db_ref;
   while(<IN>){
      chomp;
      s/^\s+|\s+$//g;
      s/^\/\/.*$//g;
      next unless length;
      my ($keywords,$keyvalues) = split /##/;
      my $obj = bless {};
      my @keywords = split /#/,$keywords;
      my @keyvalues = split /#/,$keyvalues;
      # enable easier space matching
      for($i=0;$i<=$#keywords;$i++){
         $keywords[$i] =~ s/\s+/\\s\*/g;
      }
      $obj->{keywords} = \@keywords;
      $obj->{keyvalues} = \@keyvalues;
      $obj->{id} = $db_load_count++;
      push @{$db_ref},$obj;
   }
   return $db_ref;
}

# get reply
sub getreply {
   my ($s,$db_ref) = @_;
   my $r;
   my @match_list;

   # search for a match
REFLOOP: for($db_ref_index=0;$db_ref_index<=$#{$db_ref};$db_ref_index++){
      $obj = ${$db_ref}[$db_ref_index];
      my @keywords = @{$obj->{keywords}};
      for($keywords_index=0;$keywords_index<=$#keywords;$keywords_index++){
         $_ = $keywords[$keywords_index];
         if($s =~ m/($_)/){
            $obj->{s} = length $1;
            my @vars = ($2,$3,$4,$5,$6,$7,$8,$9);
            $obj->{vars} = \@vars;
            push @match_list,$obj;
            next REFLOOP;
         }
      }
   }

   # (longer string matches get precedense over few letters matching)
   if($#match_list >= 0){

      # find max
      $obj = $match_list[0];
      for($i=1;$i<=$#match_list;$i++){
         if($obj->{s} < $match_list[$i]->{s}){
            $obj = $match_list[$i];
         }
      }
      my @keyvalues = @{$obj->{keyvalues}};
      
      my $storage_tmp_filename = "profphreak.tmp";
      dbmopen(%NUMBS,$storage_tmp_filename,0666);
      $number = int $NUMBS{ $obj->{id} };
      if($number > $#keyvalues){
         $number = 0;
      }
      $r = $keyvalues[$number++];
      $NUMBS{ $obj->{id} } = $number;
      dbmclose(%NUMBS);

      # do variable replacements
      my @vars = @{$obj->{vars}};
      for($i=0;$i<=$#vars;$i++){
         for($j=0;$j<=$#from;$j++){
            last if $vars[$i] =~ s/^$from[$j]\s/$to[$j] /g;
            last if $vars[$i] =~ s/^$from[$j]$/$to[$j]/g;
            last if $vars[$i] =~ s/\s$from[$j]\s/ $to[$j] /g;
            last if $vars[$i] =~ s/\s$from[$j]$/ $to[$j]/g;
         }
         $j = $i+1;
         $r =~ s/\$$j/$vars[$i]/g;
      }
   }
   return $r;
}

sub doreplies {
   my ($s) = @_;
   my $r = getreply($s,load_database("phreak_s.db"));
   if(!length $r){   
      $r = getreply($s,load_database("phreak_t.db"));
   }
   return $r;
}

while(<>){
   s/^\s*|\s*$//g;
   s/\.|\,|\!|\?//g;
   s/\s+/ /g;
   $_ = lc;
   s/\'re/ are/g;
   s/\'m/ am/g;
   s/\'d/ would/g;
   s/can\'t/can not/g;
   s/won\'t/will not/g;
   s/n\'t/ not/g;
   s/'s/ is/g;
   s/'ve/ have/g;
   s/^\s*|\s*$//g;
   

   $db_load_count = 0;

   $r = doreplies($_);
   print "$r\n";
}
